#!/bin/sh
# $Id: import.SH,v 1.9 2000/02/24 15:32:01 moritz Exp $
#
#  import (Netzwerk-System) (Datenformat)
#
#  Dieses Shell-Script wird von den Online-Programmen nach Austausch der
#  Daten aufgerufen. Im aktuellen Verzeichnis befinden sich die bereits
#  ausgepackten Daten (und sonst nichts). Diese muessen nun noch 
#  konvertiert und an das News/Mail-System weitergereicht werden.
#
#  Es wird angenommen, dass die Daten, die in Dateien *.prv und *.eil
#  sind, nur Mail
#  enthalten, waehrend alle Daten, die in Dateien *.brt sind, nur News
#  sind. Andere Dateien duerfen beliebige Mischungen enthalten.
#
# $Log: import.SH,v $
# Revision 1.9  2000/02/24 15:32:01  moritz
# nderungen aus dem Projekt KeinZerberus2000 eingefgt
#
# Revision 1.8  1998/04/27 10:09:28  moritz
# - import: Vermeide, Datei immer wieder einzulesen, wenn sie nicht gelscht
#   wurde
#
# Revision 1.7  1998/02/13 09:55:56  moritz
# - 'uumlist' geloescht
# - import laesst eventuelle core-Files unberuehrt
#

exec >&2

#
#  Wichtig: hier den Pfad so erweitern, das die Gateway-Programme sowie
#  smail und rnews erreichbar sind!
#
PATH=@DESTDIR@:@PATHADD@:$PATH; export PATH

#
# Kommando, um ein BSMTP-Batch einzulesen. Wird von configure geliefert.
#
BSMTPCMD="@BSMTPCMD@"

ERRDIR=@SPOOLDIR@/error
SYSTEM=$1

# report an error to postmaster and to stderr
reperr() {
	MSG=$1

	echo "$MSG" >&2
	(echo "Subject: Error in $0"
	 echo ""
         echo "id: `id` System: $SYSTEM"
	 echo "$MSG") | mail postmaster
}

# save a file $1 (in the current directory) safely into $ERRDIR
# without overwriting an existing file
errsave() {
	FILE=$1

	if [ ! -d $ERRDIR ]; then
		if mkdir $ERRDIR; then
			:
		else
			reperr "$0: kann $ERRDIR nicht anlegen!"
			return 1
		fi
	fi

	N=0

	while [ -f $ERRDIR/$FILE.$N -a $N -le 9999 ]; do
		N=`expr $N + 1`
	done
	mv $FILE $ERRDIR/$FILE.$N
}



umask 027

echo '##################################################################' >&2
date >&2
echo "Import der empfangenen Daten von $1" >&2


for file in *
do
	if [ -f $file ]; then
		case $file in
		core)
			;;
		*.prv|*.eil)
			;;
		*.brt)
			;;
		*)
			echo "Splitte $file..." >&2
			if zconsplit $file; then
				rm -f $file
				echo "Nach zconsplit:" >&2
				ls -l >&2
			else
				reperr "Fehler bei zconsplit file $file - verschiebe nach $ERRDIR"
				errsave $file
			fi
			;;
		esac
	fi
done


# now we have only .brt and .prv and .eil
for file in *; do
	if [ ! -s $file ]; then
		# file is zero length
		rm -f $file
	fi

	if [ -f $file ]; then
		BACKUPFILE="$file.import.backup"
		ln $file $BACKUPFILE
		echo "Lese $file..." >&2
		case $file in
		core)
			;;
		*.prv|*.eil)
			if uuwsmtp -f $file $1 | $BSMTPCMD $1; then
				# okay, did uuwsmtp delete $file?
				if [ -f $file ]; then
					# no, save it
					reperr "$0: uuwsmtp didnt delete $file - saving to $ERRDIR"
					errsave $file
				fi
			else
				if [ -f $file ]; then
					# uuwsmtp or $BSMTPCMD returned unsuccessfully
					reperr "uuwsmtp|$BSMTPCMD exit !=0, $file saved to $ERRDIR"
					errsave $file
				else
					reperr "uuwsmtp|$BSMTPCMD exit != 0, $file was deleted, saving backup copy $BACKUPFILE to $ERRDIR"
					errsave $BACKUPFILE
				fi
			fi
			;;
		*.brt)
			if uuwnews -f $file $1 | rnews -h $1; then
				# return success... did uuwnews delete $file?
				if [ -f $file ]; then
					# no, save it
					reperr "$0: uuwnews didnt delete $file - saving to $ERRDIR"
					errsave $file
				fi
			else
				if [ -f $file ]; then
					reperr "uuwnews|rnews exit !=0, $file saved to $ERRDIR"
					errsave $file
				else
					reperr "uuwnews|rnews exit != 0, $file was deleted, saving backup copy $BACKUPFILE to $ERRDIR"
					errsave $BACKUPFILE
				fi
			fi
			;;
		esac
		rm -f $BACKUPFILE
	fi
done

# EOF
